package com.steerinfo.baseinfo.meterbasesystemmessage.controller;

import com.steerinfo.baseinfo.meterbasesystemmessage.mapper.MeterBaseSystemMessageMapper;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasesystemmessage.model.MeterBaseSystemMessage;
import com.steerinfo.baseinfo.meterbasesystemmessage.service.IMeterBaseSystemMessageService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * MeterBaseSystemMessage RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-02-25 04:07
 * 类描述
 * 修订历史：
 * 日期：2022-02-25
 * 作者：generator
 * 参考：
 * 描述：MeterBaseSystemMessage RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbasesystemmessages")
@Api(value = "/${api.version}/meterbasesystemmessages", tags = "通知公告 - MeterBaseSystemMessageController")
public class MeterBaseSystemMessageController extends BaseRESTfulController {

    @Autowired
    IMeterBaseSystemMessageService meterBaseSystemMessageService;

    @Autowired
    MeterBaseSystemMessageMapper meterBaseSystemMessageMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasesystemmessage:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseSystemMessage> list = meterBaseSystemMessageService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasesystemmessage:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseSystemMessage> list = meterBaseSystemMessageService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasesystemmessage:view")
    @PostMapping(value = "/like/")
    public RESTfulResult listLikePost(@RequestBody HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseSystemMessage> list = meterBaseSystemMessageService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseSystemMessage对象创建")
    @ApiImplicitParam(name = "meterBaseSystemMessage", value = "详细实体meterBaseSystemMessage", required = true, dataType = "MeterBaseSystemMessage")
    //@RequiresPermissions("meterbasesystemmessage:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseSystemMessage model){
        try{
            String msg = meterBaseSystemMessageService.checkandadd(model);
            if (msg != "" && !msg.equals("")) {
                return  failed(null,msg);
            }
        }catch (Exception e){
            e.printStackTrace();
            return failed(null,"操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasesystemmessage:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseSystemMessage meterBaseSystemMessage = meterBaseSystemMessageService.getById(id);
        return success(meterBaseSystemMessage);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseSystemMessage信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseSystemMessage", value = "详细实体meterBaseSystemMessage", required = true, dataType = "MeterBaseSystemMessage")
    })
    //@RequiresPermissions("meterbasesystemmessage:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseSystemMessage model){
        model.setId(id);
        MeterBaseSystemMessage meterBaseSystemMessage = meterBaseSystemMessageService.modify(model);
        return success(meterBaseSystemMessage);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasesystemmessage:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseSystemMessageService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="系统消息已读", notes="系统消息已读")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "parma", value = "HashMap", required = true, dataType = "HashMap")
    })
    @PutMapping(value = "/updateIsRead", produces  = "application/json;charset=UTF-8")
    public RESTfulResult updateIsRead(@RequestBody HashMap parma){
        try {
            meterBaseSystemMessageMapper.updateIsRead(parma.get("systemMessageNo").toString());
        }
        catch (Exception e){
            e.printStackTrace();
            return  failed(null,"操作异常，请确认");
        }
        return success();
    }

    @ApiOperation(value="倒序获取通告列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasesystemmessage:view")
    @GetMapping(value = "/likeDesc/")
    public RESTfulResult likeDesc(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseSystemMessage> list = meterBaseSystemMessageService.likeDesc(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取最新的通告信息-App滚动条显示", notes="分页模糊查询")
    @GetMapping(value = "/getNews/")
    public RESTfulResult getNews(){
        MeterBaseSystemMessage list = meterBaseSystemMessageService.getNews();
        return success(list);
    }
}
